package se.su.dsv.scipro.daisyExternal;

import com.google.inject.AbstractModule;
import com.google.inject.name.Names;
import lombok.SneakyThrows;
import se.su.dsv.scipro.daisyExternal.http.DaisyAPI;
import se.su.dsv.scipro.daisyExternal.http.DaisyAPIImpl;
import se.su.dsv.scipro.daisyExternal.impl.ExternalImporterDaisyImpl;
import se.su.dsv.scipro.daisyExternal.impl.ImporterTransactionsImpl;

import java.io.IOException;
import java.util.Properties;

public class DaisyExternalModule extends AbstractModule {
    @Override
    protected void configure() {
        bind(ExternalImporter.class).to(ExternalImporterDaisyImpl.class);
        bind(ImporterTransactions.class).to(ImporterTransactionsImpl.class);
        bind(DaisyAPI.class).to(DaisyAPIImpl.class);

        Properties properties = loadProperties();
        bindProperty(properties, "url");
        bindProperty(properties, "user");
        bindProperty(properties, "password");
    }

    @SneakyThrows(IOException.class)
    private Properties loadProperties() {
        Properties properties = new Properties();
        properties.load(getClass().getResourceAsStream(getClass().getSimpleName() + ".properties"));
        return properties;
    }

    protected void bindProperty(Properties properties, String property) {
        bindConstant().annotatedWith(Names.named(property)).to(properties.getProperty(property));
    }
}
