package se.su.dsv.scipro.file;

import com.querydsl.jpa.impl.JPAQuery;
import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.AbstractServiceImpl;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import java.util.Collection;
import java.util.List;

public class ProjectFileRepositoryImpl extends AbstractServiceImpl<ProjectFile, Long> implements ProjectFileRepository {
    @Inject
    public ProjectFileRepositoryImpl(final Provider<EntityManager> em) {
        super(em, ProjectFile.class, QProjectFile.projectFile);
    }

    @Override
    public List<ProjectFile> latestUpload(final Project project, final int amount) {
        return new JPAQuery<ProjectFile>(em())
                .from(QProjectFile.projectFile)
                .where(QProjectFile.projectFile.project.eq(project))
                .limit(amount)
                .fetch();
    }

    @Override
    public Collection<ProjectFile> getProjectFiles(final Project project, final Pageable pageable) {
        return findAll(QProjectFile.projectFile.project.eq(project), pageable);
    }

    @Override
    public long countProjectFiles(final Project project) {
        return count(QProjectFile.projectFile.project.eq(project));
    }
}
