package se.su.dsv.scipro.firstmeeting;

import com.querydsl.core.annotations.QueryInit;
import se.su.dsv.scipro.activityplan.Activity;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.*;
import java.util.Date;

@Entity
@Table(name = "project_first_meeting")
public final class ProjectFirstMeeting extends DomainObject {
    @Id
    @GeneratedValue
    private Long id;

    @QueryInit("activityPlan.project")
    @OneToOne(optional = false, cascade = CascadeType.ALL)
    private Activity activity;

    @Basic(optional = false)
    private String room;

    protected ProjectFirstMeeting() {}

    @Override
    public Long getId() {
        return id;
    }

    public Date getDate() {
        return activity.getDate();
    }

    public String getRoom() {
        return room;
    }

    void setRoom(final String room) {
        this.room = room;
    }

    public String getDescription() {
        return activity.getDescription();
    }

    Activity getActivity() {
        return activity;
    }

    void setActivity(Activity activity) {
        this.activity = activity;
    }
}
