package se.su.dsv.scipro.forummail;

import com.querydsl.jpa.impl.JPAQuery;
import scala.Option;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;

class ForumMailGroupRepositoryImpl implements ForumMailGroupRepository {
    private final Provider<EntityManager> entityManagerProvider;

    @Inject
    ForumMailGroupRepositoryImpl(Provider<EntityManager> entityManagerProvider) {
        this.entityManagerProvider = entityManagerProvider;
    }

    @Override
    public Option<ForumMailGroup> findByThreadId(long id) {
        QForumMailGroup q = QForumMailGroup.forumMailGroup;
        ForumMailGroup forumMailProject = new JPAQuery<ForumMailGroup>(entityManagerProvider.get())
                .from(q)
                .where(q.groupThread.id.eq(id))
                .fetchOne();
        return Option.<ForumMailGroup>apply(forumMailProject);
    }
}
