package se.su.dsv.scipro.forummail;

import lombok.SneakyThrows;

import javax.mail.MessagingException;
import javax.mail.Part;
import java.io.IOException;
import java.io.InputStream;
import java.util.function.Function;

public class MailAttachment {
    private final Part part;

    public MailAttachment(final Part part) {
        this.part = part;
    }

    @SneakyThrows(MessagingException.class)
    public String getFileName() {
        return part.getFileName();
    }

    @SneakyThrows(MessagingException.class)
    public String getContentType() {
        return part.getContentType();
    }

    @SneakyThrows(MessagingException.class)
    public long getSize() {
        return part.getSize();
    }

    @SneakyThrows({MessagingException.class, IOException.class})
    public <T> T handleData(Function<InputStream, T> handler) {
        try (InputStream is = part.getInputStream()) {
            return handler.apply(is);
        }
    }
}
