package se.su.dsv.scipro.grading;

import se.su.dsv.scipro.util.Either;

import java.io.InputStream;
import java.util.Date;
import java.util.List;
import java.util.Optional;

public interface GradingService {
    List<Examination> getExaminations(String token, long projectId, long authorId);

    Optional<Result> getResult(String token, long projectId, long authorId, long examinationId);

    Either<ReportGradeError, Void> reportGrade(String token, long projectId, long authorId, int examinationId, String grade, Date reported);

    Either<UploadProtocolError, Void> sendProtocol(String token, long projectId, long authorId, int examinationId, byte[] data, String contentType);

    Either<UploadTextMatchingError, Void> sendTextMatchingDocument(String token, long projectId, InputStream data, String contentType);

    boolean hasTextMatchingDocument(String token, long projectId);
}
