package se.su.dsv.scipro.grading;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonTokenId;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonDeserializer;
import com.fasterxml.jackson.databind.exc.InvalidFormatException;

import java.io.IOException;

public class GradingTypeConverter extends JsonDeserializer<Grade.Type> {
    @Override
    public Grade.Type deserialize(final JsonParser p, final DeserializationContext ctxt) throws IOException {
        if (p.currentTokenId() == JsonTokenId.ID_STRING) {
            final String text = p.getText();
            switch (text) {
                case "G":
                    return Grade.Type.PASSING;
                case "U":
                    return Grade.Type.FAILING;
                case "T":
                    return Grade.Type.CREDITED;
                default:
                    throw new InvalidFormatException(p, "Invalid grade type", text, Grade.Type.class);
            }
        }
        throw new InvalidFormatException(p, "Grade type must be a string", null, Grade.Type.class);
    }
}
