package se.su.dsv.scipro.notifications.interfaces.impl;

import se.su.dsv.scipro.notifications.dataobject.GroupEvent;
import se.su.dsv.scipro.project.Project;

import java.text.MessageFormat;
import java.util.Set;
import java.util.stream.Collectors;

public class GroupEventFormatter extends AbstractEventFormatter<GroupEvent> {

    GroupEventFormatter(NotificationMailFormatterImpl formatter) {
        super(formatter);
    }

    @Override
    public String format(GroupEvent event) {
        String title = event.getGroup().getTitle();
        Set<Project> projects = event.getGroup().getProjects();
        String projectTitles = projects.stream().map(Project::getTitle)
                .collect(Collectors.joining(", "));
        String format = getProperty(event.getType().name());
        return MessageFormat.format(format, title, projectTitles);
    }
}
