package se.su.dsv.scipro.notifications.interfaces.impl;

import se.su.dsv.scipro.notifications.dataobject.ProjectEvent;
import se.su.dsv.scipro.project.Project;

import java.text.MessageFormat;
import java.util.function.Function;

class ProjectEventFormatter extends AbstractEventFormatter<ProjectEvent> {

    ProjectEventFormatter(NotificationMailFormatterImpl formatter) {
        super(formatter);
    }

    @Override
    public String format(ProjectEvent event) {
        Project project = event.getProject();

        String title = project.getTitle();
        String level = project.getProjectType().getName();

        String supervisor = formatUser(project.getHeadSupervisor());

        String authors = formatUserList(project.getProjectParticipants(), Function.identity());

        String coSupervisors = formatUserList(project.getCoSupervisors(), Function.identity());

        String reviewers = formatUserList(project.getReviewers(), Function.identity());

        String format = getProperty(event.getType().name());
        return MessageFormat.format(format,
                title,
                level,
                authors,
                supervisor,
                coSupervisors,
                reviewers);
    }
}
