package se.su.dsv.scipro.peer;

import com.google.inject.persist.Transactional;

import javax.inject.Inject;

public class CommentThreadServiceImpl implements CommentThreadService {

    CommentThreadRepo commentThreadRepo;

    @Inject
    public CommentThreadServiceImpl(CommentThreadRepo commentThreadRepo) {
        this.commentThreadRepo = commentThreadRepo;
    }

    @Override
    public CommentThread save(CommentThread commentThread) {
        return commentThreadRepo.save(commentThread);
    }

    @Override
    @Transactional
    public CommentThread getCommentThread(Commentable commentable) {
        final CommentThread commentThread = commentThreadRepo.getCommentThread(commentable.getCommentKey(), commentable.getId());
        if (commentThread != null) {
            return commentThread;
        } else {
            return save(new CommentThread(commentable));
        }
    }
}
