package se.su.dsv.scipro.plagiarism.urkund;

import com.google.inject.AbstractModule;
import com.google.inject.Provides;
import se.su.dsv.scipro.sukat.Sukat;

import javax.persistence.EntityManager;

public class UrkundModule extends AbstractModule {
    @Override
    protected void configure() {
        bind(UrkundService.class).to(UrkundServiceImpl.class);
        bind(UrkundSubmissionRepository.class).to(UrkundSubmissionRepositoryImpl.class);
        bind(UrkundApi.class).to(UrkundApiImpl.class);
        bind(UrkundSettingsRepository.class).to(UrkundSettingsRepositoryImpl.class);

        requireBinding(EntityManager.class);
        requireBinding(Sukat.class);
    }

    @Provides
    public UrkundSettings urkundSettings(UrkundSettingsRepository urkundSettingsRepository) {
        return urkundSettingsRepository.getSettings();
    }
}
