CREATE TABLE plagiarism_request (
  id BIGINT(20) NOT NULL AUTO_INCREMENT,
  fileDescription_id BIGINT(20) NOT NULL,
  receiver_id BIGINT(20) NOT NULL,
  PRIMARY KEY(id),
  FOREIGN KEY FK_plagiarism_request_file_description (fileDescription_id) REFERENCES file_description (id),
  FOREIGN KEY FK_plagiarism_request_receiver (receiver_id) REFERENCES user (id)
) ENGINE = InnoDB DEFAULT CHARSET = utf8;

CREATE TABLE urkund_submission (
  id BIGINT(20) NOT NULL AUTO_INCREMENT,
  dateCreated DATETIME NOT NULL,
  lastModified DATETIME NOT NULL,
  version INT(4) NOT NULL,
  fileDescription_id BIGINT(20) NOT NULL,
  receiver_id BIGINT(20) NOT NULL,
  submitted DATETIME NOT NULL,
  state VARCHAR(32) NOT NULL,
  nextPoll DATETIME NOT NULL,
  pollingDelay VARCHAR(16) NOT NULL,
  message VARCHAR(255),
  reportUrl VARCHAR(255),
  PRIMARY KEY (id),
  FOREIGN KEY FK_urkund_submission_file_description (fileDescription_id) REFERENCES file_description (id),
  FOREIGN KEY FK_urkund_submission_receiver (receiver_id) REFERENCES user (id)
) ENGINE = InnoDB DEFAULT CHARSET = utf8;
