package se.su.dsv.scipro.components;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.form.AjaxFormComponentUpdatingBehavior;
import org.apache.wicket.model.IModel;

public abstract class AjaxAutoCompleteChoice<T> extends AutoCompleteChoice<T> {


    public AjaxAutoCompleteChoice(String id) {
        super(id);
    }

    public AjaxAutoCompleteChoice(final String id, final IModel<T> model) {
        super(id, model);
    }

    @Override
    protected void onInitialize() {
        super.onInitialize();
        add(new AjaxFormComponentUpdatingBehavior("change") {
            @Override
            protected void onUpdate(AjaxRequestTarget target) {
                action(target, getModelObject());
            }
        });
    }

    protected abstract void action(AjaxRequestTarget target, T object);

}
