package se.su.dsv.scipro.components;

import org.apache.wicket.model.IModel;
import org.wicketstuff.select2.ChoiceProvider;
import org.wicketstuff.select2.Select2Choice;

// Todo: Se över autocomplete hierarkin efter att roll-ändringen är klar
public abstract class AutoCompleteChoice<T> extends Select2Choice<T> {

    public static final int MAX_RESULTS = 6;

    public AutoCompleteChoice(String id) {
        super(id);
    }

    public AutoCompleteChoice(String id, IModel<T> model) {
        super(id, model);
    }

    @Override
    protected void onInitialize() {
        setProvider(getChoiceProvider());
        super.onInitialize();
        getSettings().setCloseOnSelect(true);
        getSettings().setPlaceholder(" ");
        getSettings().setAllowClear(getAllowClear());
        getSettings().setMinimumInputLength(1);
    }

    protected abstract ChoiceProvider<T> getChoiceProvider();

    public boolean getAllowClear(){
        return true;
    }
}
