package se.su.dsv.scipro.components;

import org.apache.wicket.model.IModel;
import org.wicketstuff.select2.ChoiceProvider;
import org.wicketstuff.select2.Response;
import se.su.dsv.scipro.match.ProgramService;
import se.su.dsv.scipro.system.Program;

import javax.inject.Inject;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public abstract class ProgramAutoComplete extends AjaxAutoCompleteChoice<Program> {

    @Inject
    private ProgramService programService;

    public ProgramAutoComplete(final String id, final IModel<Program> model) {
        super(id, model);
    }

    @Override
    protected ChoiceProvider<Program> getChoiceProvider() {
        return new ProgramProvider();
    }

    private class ProgramProvider extends ChoiceProvider<Program> {

        @Override
        public String getDisplayValue(Program choice) {
            return choice.getName() + " <" + choice.getCode() + ">";
        }

        @Override
        public String getIdValue(Program choice) {
            return String.valueOf(choice.getId());
        }

        @Override
        public void query(String term, int page, Response<Program> response) {
            response.addAll(programService.getAutoCompletePrograms(term, MAX_RESULTS));
        }

        @Override
        public Collection<Program> toChoices(Collection<String> ids) {
            List<Program> programs = new ArrayList<>();
            for(String id : ids) {
                programs.add(programService.findOne(Long.valueOf(id)));
            }
            return programs;
        }
    }
}
