package se.su.dsv.scipro.reviewer.timeline;

import org.apache.wicket.markup.html.basic.EnumLabel;
import org.apache.wicket.markup.html.basic.MultiLineLabel;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;
import se.su.dsv.scipro.components.DateLabel;
import se.su.dsv.scipro.components.OrNullModel;
import se.su.dsv.scipro.data.enums.DateStyle;
import se.su.dsv.scipro.profile.UserLinkPanel;
import se.su.dsv.scipro.repository.panels.ViewAttachmentPanel;
import se.su.dsv.scipro.reviewing.Decision;
import se.su.dsv.scipro.reviewing.ReviewerApproval;

class DeniedPanel extends Panel {
    public DeniedPanel(final String id, final IModel<Decision> decision) {
        super(id);
        add(new EnumLabel<>("topic", new PropertyModel<ReviewerApproval.Step>(decision, "reviewerApproval.step")));
        add(new DateLabel("when", new PropertyModel<>(decision, "decisionDate"), DateStyle.DATETIME));
        add(new UserLinkPanel("reviewer", new PropertyModel<>(decision, "reviewerApproval.project.reviewer")));
        add(new MultiLineLabel("message", new PropertyModel<String>(decision, "reason")));
        add(new ViewAttachmentPanel("attachment", new OrNullModel<>(new PropertyModel<>(decision, "attachment"))));
        add(new ViewAttachmentPanel("gradingReport", new OrNullModel<>(new PropertyModel<>(decision, "gradingReport"))));
    }
}
