package se.su.dsv.scipro.components;

import org.apache.wicket.model.AbstractReadOnlyModel;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.util.Option;

public class OrNullModel<A> extends AbstractReadOnlyModel<A> {
    private final IModel<Option<A>> nested;

    public OrNullModel(final IModel<Option<A>> nested) {
        this.nested = nested;
    }

    @Override
    public A getObject() {
        return nested.getObject().getOrElse(() -> null);
    }

    @Override
    public void detach() {
        nested.detach();
    }
}
